<?php
/**
 * QuotationsController.
 *
 * @category  QuotationsPlusController
 *
 * @author    Roja45 <support@roja45.com>
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * @link      http://www.roja45.com/
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

/**
 * QuotationsController.
 *
 * @category  Class
 *
 * @author    Roja45 <support@roja45.com>
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * @link      http://www.roja45.com/
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

class AdminQuotationsController extends ModuleAdminController
{
    public function __construct()
    {
        parent::__construct();
        $this->context = Context::getContext();
    }

    public function postProcess()
    {
        if (Tools::getValue('submitConfiguration')) {
            $this->ajaxProcessSubmitConfiguration();
        } elseif (Tools::getValue('submitForm')) {
            $this->ajaxProcessSubmitForm();
        } else {
            die(Tools::jsonEncode(array('error' => 'method doesn\'t exist')));
        }
    }

    public function ajaxProcessSubmitConfiguration()
    {
        try {
            $validationErrors = [];

            if (!count($validationErrors)) {
                Configuration::updateGlobalValue(
                    'ROJA45_QUOTATIONS_EMAIL',
                    Tools::getValue('ROJA45_QUOTATIONS_EMAIL')
                );
                Configuration::updateGlobalValue(
                    'ROJA45_QUOTATIONS_CONTACT_NAME',
                    Tools::getValue('ROJA45_QUOTATIONS_CONTACT_NAME')
                );
                Configuration::updateGlobalValue(
                    'ROJA45_QUOTATIONS_CONTACT_BCC',
                    Tools::getValue('ROJA45_QUOTATIONS_CONTACT_BCC')
                );
                Configuration::updateGlobalValue(
                    'ROJA45_QUOTATIONS_DELETETABLES',
                    Tools::getValue('ROJA45_QUOTATIONS_DELETETABLES')
                );

                $selected_products = Tools::getValue('ROJA45_QUOTATIONS_ENABLED_PRODUCTS_selected');
                $sql = 'DELETE FROM `'._DB_PREFIX_.'roja45_product_quotations`';
                Db::getInstance()->execute($sql);
                if ($selected_products && count($selected_products) > 0) {
                    $str = '';
                    foreach ($selected_products as $product) {
                        $str .= '('.$product.',1),';
                    }

                    $str = Tools::substr($str, 0, Tools::strlen($str) - 1);
                    $sql = 'INSERT INTO `'._DB_PREFIX_.'roja45_product_quotations` VALUES '.$str;

                    if (!Db::getInstance()->execute($sql)) {
                        $validationErrors[] = $this->module->l('Unable to add product id to db.');
                    }
                }
                $this->module->clearCache();
                $json = Tools::jsonEncode(array(
                    'result' => 'success',
                    'response' => $this->l('Module Configuration Updated.'),
                ));
                die($json);
            }
            $arr2 = array(
                'result' => 'error',
                'errors' => $validationErrors,
            );
            $json = Tools::jsonEncode($arr2);
            die($json);
        } catch (Exception $e) {
            $validationErrors = [];
            $validationErrors[] = $e->getMessage();
            $json = Tools::jsonEncode(array(
                'result' => 'error',
                'errors' => $validationErrors,
                'msg' => 'Caught exception: '.$e->getMessage()."\n",
                'exception' => $e,
            ));
            die($json);
        }
    }

    public function ajaxProcessSubmitForm()
    {
        try {
            $config = Tools::jsonDecode(Tools::getValue('config'));
            $sql = '
                SELECT * FROM `'._DB_PREFIX_.'roja45_quotation_form`
                WHERE id_quotation_form="'.$config->form_id.'"';
            if (!Db::getInstance(_PS_USE_SQL_SLAVE_)->getRow($sql)) {
                Db::getInstance()->insert(
                    'roja45_quotation_form',
                    array(
                        'id_shop' => (int) $this->context->shop->id,
                        'form_columns' => $config->num_columns,
                        'form_column_titles' => $config->titles,
                    )
                );
                $form_id = Db::getInstance()->Insert_ID();
                $config->form_id = $form_id;
            } else {
                // Update it
                Db::getInstance()->update(
                    'roja45_quotation_form',
                    array(
                        'form_columns' => $config->num_columns,
                        'form_column_titles' => $config->titles,
                    ),
                    'id_quotation_form="'.$config->form_id.'" AND id_shop='.$this->context->shop->id.''
                );
            }

            // delete everything and re-insert?
            $sql = '
                DELETE FROM `'._DB_PREFIX_.'roja45_quotation_form_element`
                WHERE id_quotation_form ="'.$config->form_id.'"';
            if (Db::getInstance()->execute($sql)) {
                foreach ($config->columns as $col => $column) {
                    if ($column) {
                        foreach ($column->fields as $field) {
                            $configuration = $field->configuration;
                            $id = $field->id;
                            $name = $field->name;
                            $pos = $field->pos;
                            $type = $field->type;

                            if (($id == 'contact_email_1') || ($id == 'contact_name_1') || ($id == 'contact_subject_1')) {
                                $deletable = 0;
                            } else {
                                $deletable = 1;
                            }

                            Db::getInstance()->insert(
                                'roja45_quotation_form_element',
                                array(
                                    'id_quotation_form' => (int) $config->form_id,
                                    'form_element_id' => $id,
                                    'form_element_name' => pSQL($name),
                                    'form_element_type' => $type,
                                    'form_element_column' => $col,
                                    'form_element_position' => $pos,
                                    'form_element_deletable' => $deletable,
                                     'form_element_config' => pSQL($configuration),
                                )
                            );
                            //$item['id'] = Db::getInstance()->Insert_ID();
                        }
                    }
                }
            }

            $this->module->clearCache();
            $json = Tools::jsonEncode(array(
                'result' => 'success',
                'form' => $config,
                'response' => $this->l('Form Design Updated.'),
            ));
            die($json);
        } catch (Exception $e) {
            $validationErrors = [];
            $validationErrors[] = $e->getMessage();
            $json = Tools::jsonEncode(array(
                'result' => 'error',
                'errors' => $validationErrors,
                'msg' => 'Caught exception: '.$e->getMessage()."\n",
                'exception' => $e,
            ));
            die($json);
        }
    }
}
