<?php
/**
 * roja45quotationsQuotationsfrontModuleFrontController.
 *
 * @category  roja45quotationsQuotationsfrontModuleFrontController
 *
 * @author    Roja45 <support@roja45.com>
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * @link      http://www.roja45.com/
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

/**
 * roja45quotationsQuotationsfrontModuleFrontController.
 *
 * @category  Class
 *
 * @author    Roja45 <support@roja45.com>
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * @link      http://www.roja45.com/
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

class roja45quotationsQuotationsfrontModuleFrontController extends ModuleFrontController
{
    public function __construct()
    {
        parent::__construct();
        $this->context = Context::getContext();
    }

    public function postProcess()
    {
        if (Tools::getValue('submitQuotationRequest')) {
            $this->ajaxProcessSubmitQuotationRequest();
        } else {
            die(Tools::jsonEncode(array('error' => 'method doesn\'t exist')));
        }
    }

    public function ajaxProcessSubmitQuotationRequest()
    {
        $validationErrors = [];
        $request = Tools::jsonDecode(Tools::getValue('ROJA45_QUOTATIONS_REQUEST'));
        if (!Tools::strlen(trim(Tools::getValue('ROJA45_CONTACT_EMAIL'))) > 0) {
            $validationErrors[] = $this->module->l('Email Address Required');
        }
        if (!Tools::strlen(trim(Tools::getValue('ROJA45_CONTACT_NAME'))) > 0) {
            $validationErrors[] = $this->module->l('Contact Name Required');
        }
        if (!Tools::strlen(trim(Tools::getValue('ROJA45_QUOTATIONS_ID_PRODUCT'))) > 0) {
            $validationErrors[] = $this->module->l('Product ID Required');
        }

        if (!count($validationErrors)) {
            $email = Tools::getValue('ROJA45_CONTACT_EMAIL');
            $name = Tools::getValue('ROJA45_CONTACT_NAME');
            $customer_copy = Tools::getValue('ROJA45_QUOTATIONS_CUSTOMER_COPY');

            $productObj = new Product(Tools::getValue('ROJA45_QUOTATIONS_ID_PRODUCT'), false, (int) $this->context->language->id);
            $combinationObj = new Combination(Tools::getValue('ROJA45QUOTATIONS_ID_COMBINATION'));
            $products = [];

            $product = [];
            $product['product'] = $productObj;
            if (Validate::isLoadedObject($combinationObj)) {
                $names = $combinationObj->getAttributesName((int) $this->context->language->id);
                foreach ($names as $name) {
                    $attribute = [];
                    $attr = new Attribute($name['id_attribute'], (int) $this->context->language->id);
                    $attrGrp = new AttributeGroup($attr->id_attribute_group, (int) $this->context->language->id);
                    $attribute['name'] = $attrGrp->public_name;
                    $attribute['value'] = $name['name'];
                    $product['attributes'][] = $attribute;
                }
            }
            $products[] = $product;

            $result = $this->sendQuotation($email, $name, $products, $request, $customer_copy);

            if (!$result) {
                $validationErrors[] = $this->module->l('Unable to create quotation.');
                $arr = array(
                    'result' => 'error',
                    'errors' => $validationErrors,
                );
                $json = Tools::jsonEncode($arr);
                die($json);
            }
            $json = Tools::jsonEncode(array(
                'result' => 'success',
                'response' => $this->module->l('Request Received.'),
            ));
            die($json);
        } else {
            $arr = array(
                'result' => 'error',
                'errors' => $validationErrors,
            );
            $json = Tools::jsonEncode($arr);
            die($json);
        }
    }

    private function sendQuotation($customer_email, $customer_name, $products, $request, $customer_copy)
    {
        $html = $this->formatMessage($request, $products);
        $message_txt = new Html2Text($html);
        $text = $message_txt->getText();
        $params = array(
            '{content}' => $html,
            '{content_text}' => $text,
        );

        $to_list = [];
        $to_names = [];
        $to_list[] = Configuration::get('ROJA45_QUOTATIONS_EMAIL');
        $to_names[] = Configuration::get('ROJA45_QUOTATIONS_CONTACT_NAME');

        if ($customer_copy == 'on') {
            $to_list[] = $customer_email;
            $to_names[] = $customer_name;
        }

        if (!$bcc = Configuration::get('ROJA45_QUOTATIONS_CONTACT_BCC')) {
            $bcc = null;
        }

        $sent = Mail::Send(
            (int) $this->context->language->id,
            'roja45quotationrequest',
            sprintf(Mail::l('New Quotation Request', (int) $this->context->language->id)),
            $params,
            $to_list,
            $to_names,
            $customer_email,
            $customer_name,
            null,
            null,
            _PS_MODULE_DIR_.'roja45quotations/mails/',
            false,
            null,
            $bcc
        );

        if (!$sent) {
            return 0;
        }
        return 1;
    }

    private function formatMessage($request, $products)
    {
        $tpl = $this->context->smarty->createTemplate($this->module->getTemplatePath('quotations_html.tpl'));
        $tpl->assign(
            array(
                'languages' => Language::getLanguages(true),
                'request' => $request,
                'products' => $products,
                'defaultFormLanguage' => (int)Configuration::get('PS_LANG_DEFAULT'),
            )
        );
        return $tpl->fetch();
    }
}
