/**
 * roja45moduleadmin.js.
 *
 * @author    Roja45
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

$(document).ready(function() {

    $( '.sortable' ).sortable({
        connectWith: '.sortable',
        placeholder: 'ui-state-highlight',
        forcePlaceholderSize: true,
        dropOnEmpty: true,
        opacity: 0.8,
        tolerance: 'pointer'
    }).disableSelection();

    $('.submitConfiguration').click(function (e) {
        e.preventDefault();
        roja45quotations.saveConfig($(this));
    });
    $('#submitFormDesign').click(function (e) {
        e.preventDefault();
        roja45quotations.saveForm($(this));
    });

    // TODO - Only do this if columns have not been set from DB.
    $( ".sortable" ).on( "dragend.h5s", function( event ) {
        console.log(event.target.id);

        $('#'+event.target.id);
    });
    var num_col_prev = $( "select[name=ROJA45_QUOTATIONS_NUM_COL] option:selected").val();
    $("#ROJA45_QUOTATIONS_NUM_COL").change( function(e) {
        e.preventDefault();

        var cols = $( "select[name=ROJA45_QUOTATIONS_NUM_COL] option:selected").val();

        if (cols>1) {
            roja45quotations.displayAdPopup();
        } else {
            var error_flag = false;
            // TODO - if required cols less than # cols
            // if cols = 2

            for (i=(parseInt(cols)+1); i <= 3; i++ ) {
                if ($('*[data-column="'+i+'"] li').length > 0) {
                    // SHOW WARNING
                    error_flag = true;
                    $( "select[name=ROJA45_QUOTATIONS_NUM_COL]").val(num_col_prev);
                    $( "#fields_warning_dialog" ).dialog({
                        modal: true,
                        buttons: {
                            Ok: function() {
                                $( this ).dialog( "close" );
                            }
                        }
                    });
                }
            }
            if (!error_flag) {
                num_col_prev = cols;
                $('input[name=ROJA45_QUOTATIONS_NUM_COL]').val(cols);
                var count = 1;
                var col_width = 12;

                for (i=count; i <= cols; i++ ) {
                    if (!$('*[data-column="'+count+'"]').length > 0) {
                        // create column
                        $('#form_design_columns').append('' +
                            '<section id="sortable'+i+'" data-column="'+i+'" class="form-column col-lg-' + col_width + '">' +
                            '<section id="form_design_column_'+i+'" class="filter_panel">' +
                            '<header class="clearfix"><div class="panel-heading-icon"><i class="icon-list-ul"></i></div><div class="panel-heading-name">' +
                            '<input type="text" class="form-column-title" name="form_element_column_title_'+i+'" value="Column '+i+'" data-validate="isText" onfocus="if(this.value == \'Column '+i+'\') { this.value = \'\'; }" onblur="if(this.value == \'\') { this.value = \'Column 1\'; }"></div></header>' +
                            '<section class="filter_list"><ul class="list-unstyled droppable sortable connectedSortable"></ul></section>' +
                            '</section>' +
                            '</section>');
                    } else {
                        $('.form-column[data-column="'+count+'"]').removeClass('col-lg-12 col-lg-6 col-lg-4');
                        $('.form-column[data-column="'+count+'"]').addClass('col-lg-'+col_width);
                    }
                    count++;
                }

                for (i=count; i <= 3; i++ ) {
                    if ($('*[data-column="'+count+'"]').length > 0) {
                        // delete it
                        $('*[data-column="'+count+'"]').remove();
                    }
                    count++;
                }
                $( ".sortable" ).sortable( "destroy" );
                $( '.sortable' ).sortable({
                    connectWith: '.sortable',
                    placeholder: 'ui-state-highlight',
                    forcePlaceholderSize: true,
                    dropOnEmpty: true,
                    opacity: 0.8,
                    tolerance: 'pointer'
                }).disableSelection();

                $('#text_field_form').fadeOut( 'fast', function(e) {
                    $('#form_element_buttons').empty();
                    $( "select[name=ROJA45_QUOTATIONS_FORM_ELEMENT]").val('DEFAULT');
                });
            }
        }


    });

    $('.cancelAdd').on( 'click', function(e) {
        var form_name = '#'+$(this).closest('form').attr('id');
        $(form_name).fadeOut( 'fast', function(e) {
            $('#form_element_buttons').empty();
            $( 'select[name=ROJA45_QUOTATIONS_FORM_ELEMENT]').val('DEFAULT');
            $( 'select[name=form_element_required]').val('0');
            $( 'select[name=form_element_validation]').val('none');
            $(form_name)[0].reset();
        });
        $(this).closest('form').find("input[type=text], textarea").val("");
        $(this).closest('form').find('.form-ok').removeClass('form-ok');
        $(this).closest('form').find('.form-error').removeClass('form-error');
    });

    $('#ROJA45_QUOTATIONS_FORM_ELEMENT').change( function (e) {
        e.preventDefault();

        var element = $( "select[name=ROJA45_QUOTATIONS_FORM_ELEMENT] option:selected").val();
        var cols = $( "select[name=ROJA45_QUOTATIONS_NUM_COL] option:selected").val();

        $('.field_elements_form').fadeOut();
        switch (element) {
            case 'DEFAULT':
                $('#text_field_form').fadeOut( 'fast', function(e) {
                    $('.form_element_buttons').empty();
                });
                break;
            case 'TEXT':
                roja45quotations.selectElement('#text_field_form', element);
                break;
            case 'CHECKBOX':
                roja45quotations.displayAdPopup();
                break;
            case 'TEXTAREA':
                roja45quotations.selectElement('#textarea_field_form', element);
                break;
            case 'SWITCH':
                roja45quotations.displayAdPopup();
                break;
            case 'SELECT':
                roja45quotations.displayAdPopup();
                break;
            case 'DATE':
                roja45quotations.displayAdPopup();
                break;
        }
    });

    $('.form_element_contents').on('change', function(e) {
        e.preventDefault();
        var val = $(this).val();
        $('.field-dropdown-custom').hide();
        if (val == "0") {
            // clear options
            $('.field-dropdown-custom textarea').val('');
        } else if (val == "1") {
            $('.field-dropdown-custom').show();
        } else if (val == "2") {
            // countries
        }
    });

    $('input[name=ROJA45_QUOTATIONS_ENABLE_CAPTCHA]').on('change', function() {
        if ($("input[name='ROJA45_QUOTATIONS_ENABLE_CAPTCHA']:checked").val() == '1') {
            $('.recaptcha_hidden').fadeIn();
        } else {
            $('.recaptcha_hidden').fadeOut();
        }
    }).trigger('change');

    $('select[name=ROJA45_QUOTATIONS_REQUEST_TYPE]').on('change', function() {
        if ($(this).val() == '1') {
            $('.request-type-hidden').fadeOut();
        } else {
            $('.request-type-hidden').fadeIn();
        }
    }).trigger('change');

    roja45quotations.initFormDesignerEvents();
});

var roja45quotations = {
    initFormDesignerEvents : function () {
        $('.edit-configuration').off('click').on('click', function(e) {
            e.preventDefault();
            roja45quotations.editConfiguration($(this));
        });
        $('.delete-configuration').off('click').on('click', function(e) {
            e.preventDefault();
            roja45quotations.deleteElement($(this));
        });
    },

    displayAdPopup : function () {
        alert('Plus & Pro Only');
    },

    selectElement : function ( form, element ) {
        var cols = $( "select[name=ROJA45_QUOTATIONS_NUM_COL] option:selected").val();
        $(form +' #form_element_buttons').empty();
        for (i = 1; i <= cols; i++) {
            var width = (12/cols);
            $(form +' #form_element_buttons').append('<a href="#" data-col="'+ i + '" class="addFieldToColumn btn btn-default btn btn-default" style="margin-right: 10px;"><i class="process-icon-edit"></i>Add To Column '+i+'</a>');
        }

        $('.addFieldToColumn').on('click', function(e) {
            e.preventDefault();
            roja45quotations.processField($(this).data('col'), form, element);
        });

        $(form).fadeIn( 'fast', function(e) {

        });
    },

    processField : function (col, form, element) {
        $(form+' .alert.alert-danger').fadeOut('fast', function() {
            $(form+' .alert.alert-danger').empty();
            if (roja45quotations.validateElementForm( form )) {
                var fields = $(form).serialize();
                if (roja45quotations.addElementToColumn( col, element, $(form +' input[name=form_element_name]').val(), fields )) {
                    $(form).fadeOut( 'fast', function(e) {
                        $(form +' #form_element_buttons').empty();
                        $(form +' select[name=ROJA45_QUOTATIONS_FORM_ELEMENT]').val('DEFAULT');
                        $(form +' select[name=form_element_required]').val('0');
                        $(form +' select[name=form_element_validation]').val('none');
                        $(form)[0].reset();
                    });
                    $('select[name=ROJA45_QUOTATIONS_FORM_ELEMENT]').val('DEFAULT');
                    $(this).closest('form').find("input[type=text], textarea").val("");
                    $(this).closest('form').find('.form-ok').removeClass('form-ok');
                    $(this).closest('form').find('.form-error').removeClass('form-error');
                }
            }
        });
    },

    addElementToColumn : function (column, type, name, config) {
        var existing = $('#form_design_columns ul li[data-name='+name+']');
        if (existing.length > 0) {
            roja45global.displayErrorMsg(roja45quotations_element_name_exists);
            return false;
        }
        // TODO - Check whether name already exists, add a number to it.
        var id = '';
        if ( $('#form_design_columns #' +name+'_'+column).length > 0 ) {
            id = name+'_'+column+'_' + $('#form_design_columns #'+ name+'_'+column).length +1;
        } else {
            id = name+'_'+column;
        }

        id = id.toLowerCase().replace(/\s+/g, '');
        $('#form_design_column_' + column + ' .sortable' ).append('<li id="' + id + '" class="filter_list_item" draggable="true" data-id="' + id + '" data-type="' + type + '" data-name="' + name + '"data-column="'+column+'"> \
            <input type="hidden" name="configuration" value="' + config + '"/> \
            <input type="hidden" name="id" value="' + id + '"/> \
            <input type="hidden" name="name" value="' + name + '"/> \
            <input type="hidden" name="type" value="' + type + '"/> \
            <div class="col-lg-1 drag-icon"><h4><i class="icon-bars"></i></h4></div> \
            <div class="col-lg-5"><h4><span class="panel-heading-name">'+name+'</span></div>\
            <div class="col-lg-4"><h4><span class="panel-heading-type">['+ type +']</span></h4></div>\
            <div class="col-lg-2"><span class="panel-heading-action pull-right">\
            <a class="list-toolbar-btn edit-configuration" href="#" title="Configure"> \
            <i class="process-icon-configure"></i></a> \
            <a class="list-toolbar-btn delete-configuration" href="#" title="Delete"> \
            <i class="process-icon-delete"></i></a></span></div></li>');

        $( ".sortable" ).sortable( "destroy" );
        $( '.sortable' ).sortable({
            connectWith: '.sortable',
            placeholder: 'ui-state-highlight',
            forcePlaceholderSize: true,
            dropOnEmpty: true,
            opacity: 0.8,
            tolerance: 'pointer'
        }).disableSelection();

        roja45quotations.initFormDesignerEvents();
        return true;
    },

    editConfiguration : function (ele) {
        var type = ele.closest('.filter_list_item').attr('data-type');
        var id = ele.closest('.filter_list_item').attr('data-id');
        $('.field_elements_form').hide();
        var serialized = $('#'+id+' input[name=configuration]').val();
        var form = '#' + $('*[data-form-type="'+type+'"]').attr('id');
        $.each(serialized.split('&'), function (index, elem) {
            var vals = elem.split('=');
            $(form+" [name='" + vals[0] + "']").val(decodeURIComponent( vals[1].replace(/\+/g , " ") ));

            if ($(form+" [name='" + vals[0] + "']").is('select')) {
                $(form+" [name='" + vals[0] + "']").trigger('change');
            };
        });

        // TODO - Load config
        $(form+' #form_element_buttons').empty();
        $(form+' #form_element_buttons').append('<a href="#" data-field="'+ id + '" class="updateField btn btn-default btn btn-default" style="margin-right: 10px;"><i class="process-icon-edit"></i>Apply</a>');
        // $(form+' #form_element_buttons').append('<a href="#" class="cancelEdit btn btn-default btn btn-default" style="margin-right: 10px;"><i class="process-icon-edit"></i>Cancel</a>');
        $('.updateField').on('click', function(e) {
            e.preventDefault();
            var field = $(this).data('field');

            var form_name = '#'+$(this).closest('form').attr('id');
            // validate fields

            $(form_name+' .alert.alert-danger').fadeOut('fast', function() {
                $(form_name+' .alert.alert-danger').empty();

                if (roja45quotations.validateElementForm( form_name )) {
                    var fields = $(form_name).serialize();
                    $('#'+id+' input[name=configuration]').val(fields);

                    $('#'+id+' .panel-heading-name').html($(form_name+' input[name=form_element_name]').val());
                    $('#'+id+' input[name=name]').val($(form_name+' input[name=form_element_name]').val());

                    $(form_name).fadeOut( 'fast', function(e) {
                        $(form+' #form_element_buttons').empty();
                        $(form+' select[name=ROJA45_QUOTATIONS_FORM_ELEMENT]').val('DEFAULT');
                        $(form+' select[name=form_element_required]').val('NO');
                        $(form+' select[name=form_element_validation]').val('none');
                    });
                    $(this).closest('form').find("input[type=text], textarea").val("");
                    $(this).closest('form').find('.form-ok').removeClass('form-ok');
                    $(this).closest('form').find('.form-error').removeClass('form-error');
                }
            });
        });

        $('.cancelEdit').on( 'click', function(e) {
            var form_name = '#'+$(this).closest('form').attr('id');
            $(form_name).fadeOut( 'fast', function(e) {
                $('#form_element_buttons').empty();
                $('select[name=ROJA45_QUOTATIONS_FORM_ELEMENT]').val('DEFAULT');
                $('select[name=form_element_required]').val('NO');
                $('select[name=form_element_validation]').val('none');
                $(form_name)[0].reset();
            });
            $(this).closest('form').find("input[type=text], textarea").val("");
            $(this).closest('form').find('.form-ok').removeClass('form-ok');
            $(this).closest('form').find('.form-error').removeClass('form-error');
            $.scrollTo('#roja45quotations_form', 100);
        });

        $('*[data-form-type="'+type+'"]').fadeIn( 'fast', function(e) {

        });
    },

    deleteElement : function (ele) {
        var column = ele.closest('.filter_list_item').attr('data-column');
        var id = ele.closest('.filter_list_item').attr('data-id');
        $('#form_design_column_' + column + ' #'+id).fadeOut('fast', function(e) {
            $(this).remove();
        });
    },

    saveConfig : function ( ele ) {
        var href = $(ele).attr('href')+'&submitConfiguration=1&ajax=1';
        var selectArr = [];
        var data = $('#roja45quotations_form').serialize();

        $.ajax({
            url: href,
            type: 'post',
            dataType: 'json',
            data: data,
            beforeSend: function() {
                roja45global.toggleModal();
            },
            success: function(json) {
                if (json.result == 'success') {
                    roja45global.displaySuccessMsg(json.response);
                } else if (json.result == 'error') {
                    $.each(json.errors, function(index, value) {
                        roja45global.displayErrorMsg(value);
                    });
                } else {
                    roja45global.displayErrorMsg('An unknown error occurred.');
                }
            },
            error: function(data) {
                roja45global.displayErrorMsg(data);
            },
            complete: function(data) {
                roja45global.toggleModal();
            }
        });
    },

    saveForm : function ( ele ) {
        var href = $(ele).attr('href') + '&submitForm=1&ajax=1';
        var config = {};
        config['num_columns'] = $('input[name=ROJA45_QUOTATIONS_NUM_COL]').val();
        config['form_id'] = $('input[name=ROJA45_QUOTATIONS_FORM_ID]').val();
        config.columns = [];
        var column_titles = '';

        $('.form-column-title').each( function (i) {
            var val = $(this).val();
            if ( val != ('Column ' + (i+1)) ) {
                var id = $(this).attr('name');
                column_titles += id + '=' + val + '&';
            }
        });

        config['titles'] = column_titles.substring(0, column_titles.length-1);
        $('.form-column').each( function() {
            // column id
            var column = {};

            var col = $(this).data('column');
            column.num = col;
            // if column not default value, set name
            var col_name = $('input[name=form_element_column_title_'+col+']').val();
            if (col_name != 'Column '+col) {
                column.name = col_name;
            }

            column.fields = [];
            $(this).find('.filter_list_item').each( function(i) {
                var field = {};
                field.pos = i;

                $(this).find('input').each(function() {
                    field[$(this).attr('name')] = $(this).val();
                });
                column.fields[i] = field;
            });
            config.columns[col] = column;
        });

        if (config) {
            var json = JSON.stringify(config);

            var data = {
                "config": json
            };
            data = $(this).serialize() + "&" + $.param(data);

            $.ajax({
                url: href,
                type: 'post',
                dataType: 'json',
                data: data,
                beforeSend: function() {
                    roja45global.toggleModal();
                },
                success: function(json) {
                    if (json.result == 'success') {
                        roja45global.displaySuccessMsg(json.response);
                        $('input[name=ROJA45_QUOTATIONS_FORM_ID]').val(json.form.form_id);
                    } else if (json.result == 'error') {
                        $.each(json.errors, function(index, value) {
                            roja45global.displayErrorMsg(value);
                        });
                    } else {
                        roja45global.displayErrorMsg('An unknown error occurred.');
                    }
                },
                error: function(data) {
                    roja45global.displayErrorMsg(data);
                },
                complete: function(data) {
                    roja45global.toggleModal();
                }
            });
        }
    },

    validateElementForm : function (form) {
        var validate_fields = $(form+ ' .is_required');
        if (validate_fields.length > 0) {
            $(form+ ' .alert.alert-danger').append('<ol></ol>');
            var error_count = 0;
            validate_fields.each(function( index ) {
                var function_name = 'validate_' + $(this).data('validate');
                var string_to_test = $(this).val();

                if (typeof window[function_name] == 'function') {
                    var res = window[function_name](string_to_test);
                    if (!res) {
                        // If not inc counter
                        error_count++;
                        // add to error box
                        var field_name = $(this).closest('.form-group').find('label span').text();

                        if ($(this).attr('data-iso-code')) {
                            field_name = field_name + ' ('+$(this).attr('data-iso-code')+')';
                        }

                        $(form+ ' .alert.alert-danger ol').append('<li><b>'+field_name+'</b></li>');
                    };
                }
            });

            if (validate_fields.length == 1)
                $(form+ ' .alert.alert-danger').prepend('<p>There is 1 error</p>');
            else
                $(form+ ' .alert.alert-danger').prepend('<p>There are ' + error_count + ' errors</p>');
        }

        if (error_count == 0) {
            return true;
        } else {
            $(form+ ' .alert.alert-danger').fadeIn();
            return false;
        }
    }
}
