/**
 * roja45quotations.js.
 *
 * @author    Roja45
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

$(document).ready(function() {
    var element = $(".quotation_request_dialog_overlay").detach();
    $('body').append(element);
    element = $("#quotation_request_dialog").detach();
    $('body').append(element);
        $('.ajax_request_quote_button').each(function (index, element) {
            $(this).off('click').on('click', function (e) {
                e.preventDefault();
                roja45quotations.onRequestQuoteClick($(this));
            });
        });
        $('#add_to_cart button').each(function (index, element) {
            $(document).off('click', '#add_to_cart button');
            roja45quotations.quotation_convertButton($('#buy_block #product_page_product_id').val(), $(this));
        });

        $('.ajax_add_to_cart_button').each(function (index, element) {
            roja45quotations.quotation_convertButton($(this).attr('data-id-product'), $(this));
        });

    $(document).on('click', '#quotation_request_dialog .cross, #quotation_request_dialog .continue, .quotation_request_dialog_overlay', function(e){
        e.preventDefault();
        roja45quotations.closeDialog();
    });

    roja45quotations.init();
});

var roja45quotations = {
    init : function () {
        $('#quotation_request_dialog').off('click').on('click', '.ajax-request-quotation', function(e){
            e.preventDefault();
            roja45quotations.processSend();
        });
        $('#quotation_request_dialog').off('keypress').on('keypress', function(e){
            if(e.which == 13) {
                roja45quotations.processSend();
            }
        });

        $('#quotation_request_dialog #firstname, #quotation_request_dialog #lastname').off('focusout').on('focusout', function(e) {
            $(this).val(toTitleCase($(this).val()));
        });
    },

    toTitleCase : function (str) {
        str = str.toLowerCase();
        return str.replace(/(?:^|\s)\w/g, function(match) {
            return match.toUpperCase();
        });
    },

    closeDialog : function () {
        $('#page').removeClass('blur-background');
        $('.quotation_request_dialog_overlay').hide();
        $('#quotation_request_dialog').fadeOut('fast');
        roja45quotations.reset($('#quotation_form'));
        $('#quotation_request_dialog').off('click');
        $('#quotation_request_dialog').off('keypress');
    },

    processSend : function () {
        var errors = 0;
        $('#quotation_request_dialog input.validate, #quotation_request_dialog textarea.validate').each( function( index, value) {
            if ($(this).hasClass('is_required'))
            {
                var invalid = false;
                if ($(this).val().length == 0 ) {
                    invalid = true;
                }else if ( $(this).attr('data-validate') != 'none' ) {
                    if ($(this).attr('name') == 'postcode' && typeof(countriesNeedZipCode[$('#id_country option:selected').val()]) != 'undefined')
                        var result = window['validate_'+$(this).attr('data-validate')]($(this).val(), countriesNeedZipCode[$('#id_country option:selected').val()]);
                    else
                        var result = window['validate_'+$(this).attr('data-validate')]($(this).val())
                    if (result) {
                        invalid = false;
                    } else {
                        invalid = true;
                    }
                }

                if (invalid) {
                    $(this).parent().addClass('form-error').removeClass('form-ok');
                    errors++;
                } else {
                    $(this).parent().removeClass('form-error').addClass('form-ok');
                }
            }
        });

        if (errors == 0) {
            roja45quotations.submitQuotation();
        }
    },

    quotation_convertButton : function (id, button) {
        var selected = JSON.parse(roja45_quotations_enabled_products.replace(/&quot;/g, '"'));

        if(typeof selected[id] != 'undefined' ) {
            if (roja45quotations_type == 1) {
                button.empty();
                button.html('<span>'+roja45quotations_button_text+'</span>');
                button.removeClass('ajax_add_to_cart_button');
                button.addClass('ajax_request_quote_button');
                button.off('click', "**");
                button.on('click', function (e) {
                    e.preventDefault();
                    roja45quotations.onRequestQuoteClick($(this));
                });
            }
        }
    },

    onRequestQuoteClick : function (ele) {
        roja45quotations.init();
        $('.quotation_request_dialog_overlay').addClass('roja45quotations-darken-background');
        var id_product = ele.attr('data-id-product');
        if (!id_product){
            id_product = $('#product_page_product_id').val();
        }
        var id_combination = $('#idCombination').val();

        $('#quotation_request_dialog .page-heading').html($('input[name=DIALOG_HEADING]').val());
        $('#quotation_request_dialog input[name=ROJA45_QUOTATIONS_ID_PRODUCT]').val(id_product);
        $('#quotation_request_dialog input[name=ROJA45_QUOTATIONS_ID_COMBINATION]').val(id_combination);

        $('.quotation_request_dialog_overlay').css('width','100%');
        $('.quotation_request_dialog_overlay').css('height','100%');
        $('.quotation_request_dialog_overlay').show();

        $('#quotation_request_dialog').fadeIn('fast');
    },

    submitQuotation : function () {
        // create JSON string
        var request = {};
        request.columns = [];

        $('.quotations_request.column').each( function(i) {
            var column = {};
            var heading = $(this).find('.page-subheading').html();
            column.heading = heading;
            // column id
            var col = $(this).data('column');
            column.num = col;

            column.fields = [];

            $(this).find('.form-control').each( function(j) {
                var label = $(this).closest('.form-group').find('.control-label').html();
                var field = {};
                field.pos = j;
                field.name=$(this).attr('name');
                field.label=label.trim();
                field.value=$(this).val();
                column.fields[j] = field;
            });
            request.columns[i] = column;
        });

        var json = JSON.stringify(request);
        $.ajax({
            url: roja45quotations_controller+'?submitQuotationRequest=1&ajax=1',
            type: 'post',
            dataType: 'json',
            data: $('#quotations_form').serialize() + '&ROJA45_QUOTATIONS_REQUEST=' + json,
            beforeSend: function() {
                roja45quotations.toggleModal();
            },
            success: function(json) {
                if (json) {
                    if (json.result == 'success') {
                        roja45quotations.displaySuccessMsg(roja45quotations_sent_success);
                    } else if (json.result == 'error') {
                        roja45quotations.displayErrorMsg(roja45quotations_sent_failed);
                    } else {
                        roja45quotations.displayErrorMsg(roja45quotations_unknown_error);
                    }
                } else {
                    roja45quotations.displayErrorMsg(roja45quotations_unknown_error);
                }
            },
            error: function(data) {
                roja45quotations.displayErrorMsg(roja45quotations_unknown_error);
            },
            complete: function(data) {
                roja45quotations.toggleModal();
                $('#quotations_form').trigger("reset");
            }
        });
    },

    toggleModal : function () {
        $('#quotation_request_dialog .quotation_request_dialog_modal').toggle();
    },

    displaySuccessMsg : function ( msg ) {
        $('#quotation_request_dialog .quotation_request_dialog_msg.success h2').html(msg);
        $('#quotation_request_dialog .quotation_request_dialog_msg.success').fadeIn();
        setTimeout(function(){
            roja45quotations.closeDialog();
        }, 2500);
    },

    displayWarningMsg : function ( msg ) {

    },

    displayErrorMsg : function ( msg ) {
        $('#quotation_request_dialog .quotation_request_dialog_msg.error h2').html(msg);
        $('#quotation_request_dialog .quotation_request_dialog_msg.error').fadeIn();
    },

    reset : function () {
        $('#quotation_request_dialog .quotation_request_dialog_msg.success').hide();
        $('#quotation_request_dialog .quotation_request_dialog_msg.error').hide();
        $('#quotation_request_dialog .form-error').removeClass('form-error');
        $('#quotation_request_dialog .form-ok').removeClass('form-ok');
        $('#quotation_request_dialog').find("input[type=text], textarea").val("");
        $('#quotation_request_dialog input[name=ROJA45QUOTATIONSPLUS_CUSTOMER_COPY]').prop('checked', false);
    },
}
