/**
 * roja45quotations_catalogue.js.
 *
 * @author    Roja45
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

$(document).ready(function() {
    var element = $(".quotation_request_dialog_overlay").detach();
    $('body').before(element);
    element = $("#quotation_request_dialog").detach();
    $('body').before(element);

    $(document).on('click', '#quotation_request_dialog .cross, #quotation_request_dialog .continue, .quotation_request_dialog_overlay', function(e){
        e.preventDefault();
        roja45quotations.closeDialog();
    });

    $(document).on('click', '#grid', function(e){
        $('.ajax_request_quote_button').each( function( index, element ) {
            $(this).off('click').on('click', function (e) {
                e.preventDefault();
                roja45quotations.onRequestQuoteClick($(this));
            });
        });
    });

    $(document).on('click', '#list', function(e){
        $('.ajax_request_quote_button').each( function( index, element ) {
            $(this).off('click').on('click', function (e) {
                e.preventDefault();
                roja45quotations.onRequestQuoteClick($(this));
            });
        });
    });

    var id = $('#buy_block #product_page_product_id').val();
    var selected = JSON.parse(roja45_quotationsplus_enabled_products.replace(/&quot;/g, '"'));
    if(typeof selected[id] != 'undefined' ) {
        $('.ajax_request_quote_button').on('click', function (e) {
            e.preventDefault();
            roja45quotations.onRequestQuoteClick($(this));
        });
    }

    if (roja45quotations_show_label==1) {
        $('.ajax_block_product').each(function(index) {
            var url = $(this).find('.product_img_link').attr('href');
            var params = url.split("/");
            var id = params[params.length-1].split('-')[0];
            var selected = JSON.parse(roja45_quotationsplus_enabled_products.replace(/&quot;/g, '"'));
            if(typeof selected[id] != 'undefined' ) {
                var parent = $(this).find('.product-image-container');
                parent.append('<a class="quote-box" href="' + url + '"><span class="quote-label">' + roja45quotations_quote_link_text + '</span></a>');
            }
        });
    }

    if (roja45quotations_type==2) {
        $('input[name=ROJA45QUOTATIONSPLUS_GETQUOTECHECKBOX]').on('change', function () {
            if ($(this).is(":checked")) {
                $(this).closest('.ajax_block_product ').addClass('quoted-requested');
                $('.ajax_request_quote_button').removeClass('disabled');
            } else {
                $(this).closest('.ajax_block_product ').removeClass('quoted-requested');
                if (!$('input[name=ROJA45QUOTATIONSPLUS_GETQUOTECHECKBOX]:checked').length) {
                    $('.ajax_request_quote_button').addClass('disabled');
                }
            }
        });
    } else {
        $('.ajax_request_quote_button').removeClass('disabled');
    }

    $(document).on('click', '.ajax_request_quote_button', function(e){
       e.preventDefault();
       roja45quotations.onRequestQuoteClick($(this));
    });

    roja45quotations.init();
});


var roja45quotations = {
    init : function () {
        $('#quotation_request_dialog').off('click').on('click', '.ajax-request-quotation', function(e){
            e.preventDefault();
            roja45quotations.processSend();
        });

        $('#quotation_request_dialog').off('keypress').on('keypress', function(e){
            if(e.which == 13) {
                roja45quotations.processSend();
            }
        });

        $('#quotation_request_dialog #firstname, #quotation_request_dialog #lastname').off('focusout').on('focusout', function(e) {
            $(this).val(roja45quotations.toTitleCase($(this).val()));
        });
    },

    toTitleCase : function (str) {
        str = str.toLowerCase();
        return str.replace(/(?:^|\s)\w/g, function(match) {
            return match.toUpperCase();
        });
    },

    closeDialog : function () {
        $('#page').removeClass('blur-background');
        $('.quotation_request_dialog_overlay').hide();
        $('#quotation_request_dialog').fadeOut('fast');
        roja45quotations.reset($('#quotation_form'));
        $('#quotation_request_dialog').off('click');
        $('#quotation_request_dialog').off('keypress');
    },

    processSend: function () {
        var errors = 0;
        roja45quotations.toggleModal();
        $('#quotation_request_dialog input.validate, #quotation_request_dialog textarea.validate').each(function (index, value) {
            if ($(this).hasClass('is_required')) {
                var invalid = false;

                if ($(this).val().length == 0) {
                    invalid = true;
                } else if ($(this).attr('data-validate') != 'none') {
                    if ($(this).attr('name') == 'postcode' && typeof(countriesNeedZipCode[$('#id_country option:selected').val()]) != 'undefined')
                        var result = window['validate_' + $(this).attr('data-validate')]($(this).val(), countriesNeedZipCode[$('#id_country option:selected').val()]);
                    else
                        var result = window['validate_' + $(this).attr('data-validate')]($(this).val())

                    if (result) {
                        invalid = false;
                    } else {
                        invalid = true;
                    }
                }

                if (invalid) {
                    $(this).parent().addClass('form-error').removeClass('form-ok');
                    errors++;
                } else {
                    $(this).parent().removeClass('form-error').addClass('form-ok');
                }
            }
        });

        if (errors == 0) {
            roja45quotations.submitQuotation();
        } else {
            roja45quotations.toggleModal();
        }
    },

    onRequestQuoteClick : function (ele) {

        $('#quotationsplus_request_products').empty();

        if (roja45quotations_type==2) {
            var products = [];
            $($('input[name=ROJA45QUOTATIONSPLUS_GETQUOTECHECKBOX]:checked')).each(function (index, value) {
                var url = $(this).closest('.ajax_block_product').find('.product_img_link').attr('href');
                var params = url.split("/");
                var id = params[params.length - 1].split('-')[0];
                var name = $(this).closest('.ajax_block_product').find('a.product-name').text();
                var image_url = $(this).closest('.ajax_block_product').find('.product_img_link img').attr('src');
                products.push(id);
                $('#quotationsplus_request_products').append('<div class="cart_product"><img src="' + image_url + '" alt="' + name + '" title="' + name + '"></div>')
            });
            $('input[name=ROJA45QUOTATIONSPLUS_ID_PRODUCT]').val(JSON.stringify(products));
        } else {
            var url = ele.closest('.ajax_block_product').find('.product_img_link').attr('href');
            var params = url.split("/");
            var id = params[params.length - 1].split('-')[0];
            var name = ele.closest('.ajax_block_product').find('a.product-name').text();
            var image_url = ele.closest('.ajax_block_product').find('.product_img_link img').attr('src');
            $('#quotationsplus_request_products').append('<div class="cart_product"><img src="' + image_url + '" alt="' + name + '" title="' + name + '"></div>')
            $('input[name=ROJA45QUOTATIONSPLUS_ID_PRODUCT]').val(id);
        }
        $('#quotationsplus_request_products').show();
        roja45quotations.init();
        $('.quotation_request_dialog_overlay').addClass('roja45quotations-darken-background');
        $('#quotation_request_dialog .page-heading').html($('input[name=DIALOG_HEADING]').val());
        $('.quotation_request_dialog_overlay').css('width', '100%');
        $('.quotation_request_dialog_overlay').css('height', '100%');
        $('.quotation_request_dialog_overlay').show();
        $('#quotation_request_dialog').fadeIn('fast');
    },

    submitQuotation: function () {
        var request = {};
        request.columns = [];

        $('.quotationsplus_request.column').each(function (i) {
            var column = {};
            var heading = $(this).find('.page-subheading').html();
            column.heading = heading;
            // column id
            var col = $(this).data('column');
            column.num = col;

            column.fields = [];

            $(this).find('.form-control').each(function (j) {
                var label = $(this).closest('.form-group').find('.control-label').html();
                var field = {};
                field.pos = j;
                field.name = $(this).attr('name');
                field.label = label.trim();
                field.value = $(this).val();
                column.fields[j] = field;
            });
            request.columns[i] = column;
        });

        var json = JSON.stringify(request);
        var data = {
            'ROJA45QUOTATIONSPLUS_REQUEST': json,
            'ROJA45QUOTATIONSPLUS_CONTACT_EMAIL': $('input[name=CONTACT_EMAIL]').val(),
            'ROJA45QUOTATIONSPLUS_CONTACT_NAME': $('input[name=CONTACT_NAME]').val(),
            'g-recaptcha-response': $('input[name=g-recaptcha-response]').val(),
            'ROJA45QUOTATIONSPLUS_CUSTOMER_COPY': $('input[name=ROJA45QUOTATIONSPLUS_CUSTOMER_COPY]').val()
        };
        data = $(this).serialize() + "&" + $.param(data);

        var request = '';
        if (roja45quotations_type==2) {
            request = 'submitQuotationMultipleRequest';
        } else {
            request = 'submitQuotationRequest';
        }
        $.ajax({
            url: roja45quotations_controller + '?'+request+'=1&ajax=1',
            type: 'post',
            dataType: 'json',
            data: $('#quotationsplus_form').serialize() + '&ROJA45QUOTATIONSPLUS_REQUEST=' + json,
            success: function (json) {
                if (json) {
                    if (json.result == 'success') {
                        roja45quotations.displaySuccessMsg(roja45quotations_sent_success);
                    } else if (json.result == 'error') {
                        roja45quotations.displayErrorMsg(roja45quotations_sent_failed);
                    } else {
                        roja45quotations.displayErrorMsg(roja45quotations_unknown_ewrror);
                    }
                } else {
                    roja45quotations.displayErrorMsg(roja45quotations_unknown_ewrror);
                }
            },
            error: function (data) {
                roja45quotations.displayErrorMsg(roja45quotations_sent_failed);
            },
            complete: function (data) {
                roja45quotations.toggleModal();
                $('#quotationsplus_form').trigger("reset");
                if (roja45quotations_type==2) {
                    $('input[name=ROJA45QUOTATIONSPLUS_GETQUOTECHECKBOX]').removeAttr('checked');
                    $('.roja45quotations_checkbox_container .checker span').removeClass('checked');
                    $('.ajax_block_product').removeClass('quoted-requested');
                    $('.ajax_request_quote_button').addClass('disabled');
                }
                if(roja45quotations_enable_captcha) {
                    if (typeof grecaptcha != 'undefined') {
                        grecaptcha.reset();
                    }
                }
            }
        });
    },

    toggleModal : function () {
        $('#quotation_request_dialog .quotation_request_dialog_modal').toggle();
    },

    displaySuccessMsg : function ( msg ) {
        $('#quotation_request_dialog .quotation_request_dialog_msg.success h2').html(msg);
        $('#quotation_request_dialog .quotation_request_dialog_msg.success').fadeIn();
        setTimeout(function(){
            roja45quotations.closeDialog();
        }, 2500);
    },

    displayWarningMsg : function ( msg ) {

    },

    displayErrorMsg : function ( msg ) {
        $('#quotation_request_dialog .quotation_request_dialog_msg.error h2').html(msg);
        $('#quotation_request_dialog .quotation_request_dialog_msg.error').fadeIn();
    },

    reset : function () {
        $('#quotation_request_dialog .quotation_request_dialog_msg.success').hide();
        $('#quotation_request_dialog .quotation_request_dialog_msg.error').hide();
        $('#quotation_request_dialog .form-error').removeClass('form-error');
        $('#quotation_request_dialog .form-ok').removeClass('form-ok');
        $('#quotation_request_dialog').find("input[type=text], textarea").val("");
        $('#quotation_request_dialog input[name=ROJA45QUOTATIONSPLUS_CUSTOMER_COPY]').prop('checked', false);
    }
}
