/**
 * roja45quotationsplaus.js.
 *
 * @author    Roja45
 * @copyright 2016 Roja45
 * @license   license.txt
 *
 * 2016 ROJA45 - All rights reserved.
 *
 * DISCLAIMER
 * Changing this file will render any support provided by us null and void.
 */

$(document).ready(function() {
    var element = $(".quotation_request_dialog_overlay").detach();
    $('body').append(element);
    element = $("#quotation_request_dialog").detach();
    $('body').append(element);

    if (roja45quotations_type == 2) {
        if (roja45quotations_multiple_display_type == 1) {
            roja45quotations.quotation_addButton();
        } else if (roja45quotations_multiple_display_type == 2) {
            var selected = JSON.parse(roja45quotations_cart_products.replace(/&quot;/g, '"'));
            $.each(selected, function(index, value) {
                var enabled = JSON.parse(roja45_quotationsplus_enabled_products.replace(/&quot;/g, '"'));
                var id = value.id_product;
                if (enabled[id]) {
                    roja45quotations.quotation_addButton();
                    return false;
                }
                return true;
            });
            // get list of products in the cart, check each, if 1 in selected list, call add button method
        }
    }
    $(document).on('click', '#quotation_request_dialog .cross, #quotation_request_dialog .continue, .quotation_request_dialog_overlay', function(e){
        e.preventDefault();
        roja45quotations.closeDialog();
    });
    roja45quotations.init();

    $('.cart_quantity_delete').on('click', function(e) {
        // if no more quotable, hide button.
        var deleted = $(this).attr('id').split('_')[0];
        var products = [];
        $('#cart_summary tbody tr').each(function(index, value) {
            var id = $(value).attr('id');
            var name = $(value).find('.product-name a').text();
            var res = id.split('_');
            products.push(res[1]);
        });
        products.splice($.inArray(deleted, products),1);
        $('.ajax_order_request_quote_button').fadeOut();
        $.each(products, function(index, value) {
            var enabled = JSON.parse(roja45_quotationsplus_enabled_products.replace(/&quot;/g, '"'));
            if (enabled[value]) {
                $('.ajax_order_request_quote_button').fadeIn();
                return false;
            }
            return true;
        });

    });
});

var roja45quotations = {
    init: function () {
        $('#quotation_request_dialog').off('click').on('click', '.ajax-request-quotation', function (e) {
            e.preventDefault();
            roja45quotations.processSend();
        });
        $('#quotation_request_dialog').off('keypress').on('keypress', function (e) {
            if (e.which == 13) {
                roja45quotations.processSend();
            }
        });

        $('#quotation_request_dialog #firstname, #quotation_request_dialog #lastname').off('focusout').on('focusout', function (e) {
            $(this).val(toTitleCase($(this).val()));
        });
    },

    toTitleCase: function (str) {
        str = str.toLowerCase();
        return str.replace(/(?:^|\s)\w/g, function (match) {
            return match.toUpperCase();
        });
    },

    closeDialog: function () {
        $('#page').removeClass('blur-background');
        $('.quotation_request_dialog_overlay').hide();
        $('#quotation_request_dialog').fadeOut('fast');
        roja45quotations.reset($('#quotation_form'));
        $('#quotation_request_dialog').off('click');
        $('#quotation_request_dialog').off('keypress');
    },

    processSend: function () {
        var errors = 0;
        roja45quotations.toggleModal();
        $('#quotation_request_dialog input.validate, #quotation_request_dialog textarea.validate').each(function (index, value) {
            if ($(this).hasClass('is_required')) {
                var invalid = false;

                if ($(this).val().length == 0) {
                    invalid = true;
                } else if ($(this).attr('data-validate') != 'none') {
                    if ($(this).attr('name') == 'postcode' && typeof(countriesNeedZipCode[$('#id_country option:selected').val()]) != 'undefined')
                        var result = window['validate_' + $(this).attr('data-validate')]($(this).val(), countriesNeedZipCode[$('#id_country option:selected').val()]);
                    else
                        var result = window['validate_' + $(this).attr('data-validate')]($(this).val())

                    if (result) {
                        invalid = false;
                    } else {
                        invalid = true;
                    }
                }

                if (invalid) {
                    $(this).parent().addClass('form-error').removeClass('form-ok');
                    errors++;
                } else {
                    $(this).parent().removeClass('form-error').addClass('form-ok');
                }
            }
        });

        if (errors == 0) {
            roja45quotations.submitQuotation();
        } else {
            roja45quotations.toggleModal();
        }
    },

    quotation_addButton: function () {
        var button = $('.cart_navigation .standard-checkout').clone();
        button.removeClass('standard-checkout');
        button.addClass('ajax_order_request_quote_button');
        button.attr('href', '#');
        button.attr('title', roja45quotations_button_text);
        button.find('span').html(roja45quotations_button_text+'<i class="icon-chevron-right right"></i>');
        button.off('click', "**");
        button.on('click', function (e) {
            e.preventDefault();
            roja45quotations.onRequestQuoteClick($(this));
        });

        $('#order .cart_navigation').append(button);
    },

    onRequestQuoteClick: function (ele) {
        var products = [];
        $('#quotationsplus_request_products').empty();
        $('#cart_summary tbody tr').each(function(index, value) {
            var id = $(value).attr('id');
            var name = $(value).find('.product-name a').text();
            var url = $(value).find('.cart_product a img').attr('src');
            var res = id.split('_');
            var prd = [res[1], name, url];
            products.push(prd);
            $('#quotationsplus_request_products').append('<div class="cart_product"><img src="'+url+'" alt="'+name+'" title="'+name+'" width="'+$(value).find('.cart_product a img').attr('width')+'" height="'+$(value).find('.cart_product a img').attr('height')+'"></div>')
        });
        $('#quotationsplus_request_products').show();
        roja45quotations.init();

        $('.quotation_request_dialog_overlay').addClass('roja45quotations-darken-background');
        var id_product = ele.attr('data-id-product');
        if (!id_product) {
            id_product = $('#product_page_product_id').val();
        }
        var id_combination = $('#idCombination').val();

        $('#quotation_request_dialog .page-heading').html($('input[name=DIALOG_HEADING]').val());
        $('#quotation_request_dialog input[name=ID_PRODUCT]').val(id_product);
        $('#quotation_request_dialog input[name=ID_COMBINATION]').val(id_combination);

        $('.quotation_request_dialog_overlay').css('width', '100%');
        $('.quotation_request_dialog_overlay').css('height', '100%');
        $('.quotation_request_dialog_overlay').show();

        $('#quotation_request_dialog').fadeIn('fast');
    },

    submitQuotation: function () {
        // create JSON string
        var request = {};
        request.columns = [];

        $('.quotationsplus_request.column').each(function (i) {
            var column = {};
            var heading = $(this).find('.page-subheading').html();
            column.heading = heading;
            // column id
            var col = $(this).data('column');
            column.num = col;

            column.fields = [];

            $(this).find('.form-control').each(function (j) {
                var label = $(this).closest('.form-group').find('.control-label').html();
                var field = {};
                field.pos = j;
                field.name = $(this).attr('name');
                field.label = label.trim();
                field.value = $(this).val();
                column.fields[j] = field;
            });
            request.columns[i] = column;
        });

        var json = JSON.stringify(request);
        var data = {
            'ROJA45QUOTATIONSPLUS_REQUEST': json,
            'ROJA45QUOTATIONSPLUS_CONTACT_EMAIL': $('input[name=CONTACT_EMAIL]').val(),
            'ROJA45QUOTATIONSPLUS_CONTACT_NAME': $('input[name=CONTACT_NAME]').val(),
            'g-recaptcha-response': $('input[name=g-recaptcha-response]').val(),
            'ROJA45QUOTATIONSPLUS_CUSTOMER_COPY': $('input[name=ROJA45QUOTATIONSPLUS_CUSTOMER_COPY]').val()
        };
        data = $(this).serialize() + "&" + $.param(data);

        $.ajax({
            url: roja45quotations_controller + '?submitQuotationMultipleRequest=1&ajax=1',
            type: 'post',
            dataType: 'json',
            data: $('#quotationsplus_form').serialize() + '&ROJA45QUOTATIONSPLUS_REQUEST=' + json,
            success: function (json) {
                if (json) {
                    if (json.result == 'success') {
                        roja45quotations.displaySuccessMsg(roja45quotations_sent_success);
                    } else if (json.result == 'error') {
                        roja45quotations.displayErrorMsg(roja45quotations_sent_failed);
                    } else {
                        roja45quotations.displayErrorMsg(roja45quotations_unknown_ewrror);
                    }
                } else {
                    roja45quotations.displayErrorMsg(roja45quotations_unknown_ewrror);
                }
            },
            error: function (data) {
                roja45quotations.displayErrorMsg(roja45quotations_sent_failed);
            },
            complete: function (data) {
                roja45quotations.toggleModal();
                $('#quotationsplus_form').trigger("reset");
                if(roja45quotations_enable_captcha) {
                    if (typeof grecaptcha != 'undefined') {
                        grecaptcha.reset();
                    }
                }
            }
        });
    },

    toggleModal: function () {
        $('#quotation_request_dialog .quotation_request_dialog_modal').toggle();
    },

    displaySuccessMsg: function (msg) {
        $('#quotation_request_dialog .quotation_request_dialog_msg.success h2').html(msg);
        $('#quotation_request_dialog .quotation_request_dialog_msg.success').fadeIn();
        setTimeout(function () {
            roja45quotations.closeDialog();
        }, 2500);
    },

    displayWarningMsg: function (msg) {

    },

    displayErrorMsg: function (msg) {
        $('#quotation_request_dialog .quotation_request_dialog_msg.error h2').html(msg);
        $('#quotation_request_dialog .quotation_request_dialog_msg.error').fadeIn();
    },

    reset: function () {
        $('#quotation_request_dialog .quotation_request_dialog_msg.success').hide();
        $('#quotation_request_dialog .quotation_request_dialog_msg.error').hide();
        $('#quotation_request_dialog .form-error').removeClass('form-error');
        $('#quotation_request_dialog .form-ok').removeClass('form-ok');
        $('#quotation_request_dialog').find("input[type=text], textarea").val("");
        $('#quotation_request_dialog input[name=ROJA45QUOTATIONSPLUS_CUSTOMER_COPY]').prop('checked', false);
    }
}
